﻿using UnityEngine;
using System.Collections;

public class BulletController : MonoBehaviour {

	private float speed = 5.0f;
	private bool _shouldBeDestroyed = false;

	// Update is called once per frame
	public void UpdateBullet (MainGameControllerBehaviour.GameState currentState) {
		if(currentState == MainGameControllerBehaviour.GameState.Paused) {
			rigidbody2D.velocity = new Vector2(0.0f, 0.0f);
		} else {
			rigidbody2D.velocity = new Vector2(0.0f, speed);
		}
	}

	void OnCollisionEnter2D (Collision2D colInfo) {
		// Destroy if the bullet is out of the scene
		if(colInfo.collider.tag == "TopWall") {
			SetToDestroy();
		}
	}

	/*
	 * Returns whether this bullet should be destroyed or not
	 */
	public bool ShouldBeDestroyed
	{
		get { return _shouldBeDestroyed; }
	}

	/*
	 * Sets this bullet to be destroyed 
	 */
	private void SetToDestroy() {
		_shouldBeDestroyed = true;
	}

	/*
	 * Destroys this object
	 */
	public void DestroyBullet() {
		Destroy(gameObject);
	}
}
