﻿using UnityEngine;
using System.Collections;

public class PlanetBehaviour : MonoBehaviour {

	private float _movementSpeed = 0f;
	private bool _shouldBeDestroyed = false;

	void Start() {
		// Randomize starting information (location, speed, size)
		_movementSpeed = Random.Range(0.08f, 0.5f);

		float planetSize = Random.Range(0.1f, 0.8f);
		transform.localScale = new Vector3(planetSize, planetSize, 1.0f);

		float randomRotation = Random.Range(0, 360);
		transform.eulerAngles = new Vector3(0, 0, randomRotation);

		int planetDrawingLayer = Random.Range(-100, 100);
		renderer.sortingOrder = planetDrawingLayer;
	}

	// Update is called once per frame
	public void UpdatePlanet (MainGameControllerBehaviour.GameState currentState) {
		if (currentState == MainGameControllerBehaviour.GameState.Paused) {
			rigidbody2D.velocity = Vector2.zero;
		} else {
			rigidbody2D.velocity = new Vector2(0.0f, _movementSpeed * -1);
		}
	}

	/*
	 * Only remove the planet when it's well outside the scene
	 */
	void OnTriggerExit2D(Collider2D colInfo) {
		if (colInfo.gameObject.tag == "BottomWall") {
			_shouldBeDestroyed = true;
		}
	}

	/*
	 * Returns whether this planet should be destroyed or not
	 */
	public bool ShouldBeDestroyed
	{
		get { return _shouldBeDestroyed; }
	}

	/*
	 * Destroys this planet object
	 */
	public void DestroyPlanet() {
		Destroy(gameObject);
	}
}
